/**************************************************************************                      
 *
 *      Copyright 2000-2002 Viola Systems Ltd.
 *       All Rights Reserved
 *
 * File Name      : udpinterface.c
 * Description    : This file contains the application code using UDP 
 *                    protocol functions on the MC9S12NE64. 
 *
 * Version : 1.0
 *
 ***************************************************************************/
 
#include "debug.h"
#include "datatypes.h"
#include "globalvariables.h"
#include "system.h"
#include "tcp_ip.h"

#include "string.h"
#include "MOTTYPES.h"
#include "MC9S12NE64.h"

/* These will probably go to some include file */
void udp_demo_init(void);
void udp_demo_run(void);
INT32 udp_demo_eventlistener(INT8 , UINT8 , UINT32 , UINT16 , UINT16 , UINT16 );

static unsigned char data_buffer [128];
INT8 udp_demo_soch;
UINT8 udp_demo_senddata; /**< Used to trigger data sending */

#define UDP_DEMO_PORT	2001 /**< UDP_DEMO_RMTHOST_PRT number on which we'll work */
#define UDP_DEMO_RMTHOST_IP	0xC0A80201	/**< Remote IP address this application will send data to*/
#define UDP_DEMO_RMTHOST_PRT	2000	/**< UDP_DEMO_RMTHOST_PRT number on remote server we'll send data to */

/* Internal function used for sending data to a predefined host */
void udp_demo_send(void);
extern void sendtext(tS08 * s);

//============================================================
//============================================================
#define GAMEMODE  0
#define DEMOBOARD 1

extern tU16 Pot;
extern tU16 OldPot;
extern tU08 OldSwitchValue;
extern tU08 OldB1;
extern tU08 OldB2;
extern tU08 OldB3;
extern tU08 OldB4;

signed char cvt[16]={ '0','1','2','3','4','5','6','7','8','9',
                      'A','B','C','D','E','F' };
signed char cvtd[10]={ '0','1','2','3','4','5','6','7','8','9'};



//============================================================
void ctoh (signed char * s, unsigned char c)  {
  *s= cvt[c / 16];
  s++;
  *s= cvt[c % 16];
}

//============================================================
//NEED TO MAKE THIS GENERIC FOR ANY SIZE DEC DIGIT
//============================================================
signed char* xxxxDEC_TO_ASCII(UINT16 c)	{
				
  signed char s[5];
  UINT16 divider;
  UINT8 leaddigit;
  UINT8 foundmsd;
  UINT8	 j;

  divider = 1000;
  j = 0;
  foundmsd = FALSE;
  //div 1000 
  leaddigit = (UINT8)(c / divider);
  if  (leaddigit == 0) {
    divider = divider/10;
  }
  else {
    s[j] = cvtd[leaddigit];
    c = c - leaddigit * divider;
    divider = divider/10;
    j=j+1;
    foundmsd = TRUE;
  }
  //div 100 
  leaddigit = (UINT8)(c / divider);
  if  ((leaddigit == 0) && (!foundmsd)) {
    divider = divider/10;	 
  }
  else {
    s[j] = cvtd[leaddigit];
    c = c - leaddigit * divider;
    divider = divider/10;
    j=j+1;
    foundmsd = TRUE;
  }
  //div 10 
  leaddigit = (UINT8)(c / divider);
  if  ((leaddigit == 0) && (!foundmsd)) {
    divider = divider/10;
  }
  else {
    s[j] = cvtd[leaddigit];
    c = c - leaddigit * divider;
    divider = divider/10;
    j=j+1;
    foundmsd = TRUE;
  }
  //div 1 
  leaddigit = (UINT8)(c / divider);
  s[j] = cvtd[leaddigit];
  j=j+1;
  s[j]=0;
  return s;

}

//============================================================
// Poll ATD and send new values via UDP
//============================================================
UINT16 get_a2d(char channel)			{

    UINT16 temp;
 		UINT16	i, datalen;
    signed char* s;

	  if (ATDSTAT0_SCF == 1)  {  
	  	temp =   ATDDR0;// 10-bit					
	  	Pot = temp >> 6;
		  ATDCTL5 = channel | ATDCTL5_SCAN; 
#if !(DEMOBOARD)        
      Pot = 1023-Pot;          
#endif
		  if (Pot > OldPot)
		    temp = Pot - OldPot;
		  else
		    temp = OldPot - Pot;
      if ((Pot !=  OldPot) && (temp > 8))	 {
              OldPot = Pot;
              i = 0;       net_buf[UDP_APP_OFFSET+i]='c';
              i = 1;       net_buf[UDP_APP_OFFSET+i]='o';
              i = 2;       net_buf[UDP_APP_OFFSET+i]='m';
              i = 3;       net_buf[UDP_APP_OFFSET+i]='m';
              i = 4;       net_buf[UDP_APP_OFFSET+i]='D';
              i = 5;       net_buf[UDP_APP_OFFSET+i]='I';
              i = 6;       net_buf[UDP_APP_OFFSET+i]='A';
              i = 7;       net_buf[UDP_APP_OFFSET+i]='@';
              i = 8;       net_buf[UDP_APP_OFFSET+i]='e';
              i = 9;       net_buf[UDP_APP_OFFSET+i]='q';
              i = 10;      net_buf[UDP_APP_OFFSET+i]='@';
             	s = xxxxDEC_TO_ASCII(Pot);
              while (*s != 0) {
                 i = i + 1;
                 net_buf[UDP_APP_OFFSET+i]=*s;
                 s++;
              }		 
              datalen = i+1;       
             	(void)udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
         			return Pot;
        }
	}
	return Pot;
}

//============================================================
//============================================================
void check_switch() {

 		UINT8	temp, i;
		UINT16 datalen;

			datalen=13;
      i = 0;       net_buf[UDP_APP_OFFSET+i]='c';
      i = 1;       net_buf[UDP_APP_OFFSET+i]='o';
      i = 2;       net_buf[UDP_APP_OFFSET+i]='m';
      i = 3;       net_buf[UDP_APP_OFFSET+i]='m';
      i = 4;       net_buf[UDP_APP_OFFSET+i]='R';
      i = 5;       net_buf[UDP_APP_OFFSET+i]='C';
      i = 6;       net_buf[UDP_APP_OFFSET+i]='V';
      i = 7;       net_buf[UDP_APP_OFFSET+i]='@';
      i = 8;       net_buf[UDP_APP_OFFSET+i]='e';
      i = 9;       net_buf[UDP_APP_OFFSET+i]='q';
      i = 10;      net_buf[UDP_APP_OFFSET+i]='@';
      i = 11;			 net_buf[UDP_APP_OFFSET+i]='s';
      i = 12;
      if (PTG_PTG4 == 0) {
            net_buf[UDP_APP_OFFSET+i]='0';
      			temp = FALSE;
      }
      else {
            net_buf[UDP_APP_OFFSET+i]='1';
      			temp = TRUE;
      }
		  if (OldSwitchValue !=  temp)
		      udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
      OldSwitchValue =  temp;
}

//============================================================
//============================================================
void get_led_state(void){

		  UINT16 	i, datalen;

			datalen=14;
			//LED1   
      i = 0;       net_buf[UDP_APP_OFFSET+i]='c';
      i = 1;       net_buf[UDP_APP_OFFSET+i]='o';
      i = 2;       net_buf[UDP_APP_OFFSET+i]='m';
      i = 3;       net_buf[UDP_APP_OFFSET+i]='m';
      i = 4;       net_buf[UDP_APP_OFFSET+i]='R';
      i = 5;       net_buf[UDP_APP_OFFSET+i]='C';
      i = 6;       net_buf[UDP_APP_OFFSET+i]='V';
      i = 7;       net_buf[UDP_APP_OFFSET+i]='@';
      i = 8;       net_buf[UDP_APP_OFFSET+i]='e';
      i = 9;       net_buf[UDP_APP_OFFSET+i]='q';
      i = 10;      net_buf[UDP_APP_OFFSET+i]='@';
      if (PTG_PTG0 == 0)			{				            
          i = 11;      net_buf[UDP_APP_OFFSET+i]='l';
          i = 12;      net_buf[UDP_APP_OFFSET+i]='1';
          i = 13;      net_buf[UDP_APP_OFFSET+i]='n';
    		  (void)udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
#if (GAMEMODE)               
          i = 0;       net_buf[UDP_APP_OFFSET+i]='c';
          i = 1;       net_buf[UDP_APP_OFFSET+i]='o';
          i = 2;       net_buf[UDP_APP_OFFSET+i]='m';
          i = 3;       net_buf[UDP_APP_OFFSET+i]='m';
          i = 4;       net_buf[UDP_APP_OFFSET+i]='C';
          i = 5;       net_buf[UDP_APP_OFFSET+i]='o';
          i = 6;       net_buf[UDP_APP_OFFSET+i]='n';
          i = 7;       net_buf[UDP_APP_OFFSET+i]='n';
          i = 8;       net_buf[UDP_APP_OFFSET+i]='e';
          i = 9;       net_buf[UDP_APP_OFFSET+i]='c';
          i = 10;      net_buf[UDP_APP_OFFSET+i]='t';
          i = 11;      net_buf[UDP_APP_OFFSET+i]='@';
          i = 12;      net_buf[UDP_APP_OFFSET+i]='e';
          i = 13;      net_buf[UDP_APP_OFFSET+i]='q';
          i = 14;      net_buf[UDP_APP_OFFSET+i]='@';
          i = 15;      net_buf[UDP_APP_OFFSET+i]='t';
          i = 16;      net_buf[UDP_APP_OFFSET+i]='r';
          i = 17;      net_buf[UDP_APP_OFFSET+i]='u';
          i = 18;      net_buf[UDP_APP_OFFSET+i]='e';
          (void)udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,i+1);  		  
#endif //(GAMEMODE)  
      }
      else 	 {
        i = 11;      net_buf[UDP_APP_OFFSET+i]='l';
        i = 12;      net_buf[UDP_APP_OFFSET+i]='1';    
        i = 13;      net_buf[UDP_APP_OFFSET+i]='f';
  		  (void)udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
      }
      //LED2
      i = 0;       net_buf[UDP_APP_OFFSET+i]='c';
      i = 1;       net_buf[UDP_APP_OFFSET+i]='o';
      i = 2;       net_buf[UDP_APP_OFFSET+i]='m';
      i = 3;       net_buf[UDP_APP_OFFSET+i]='m';
      i = 4;       net_buf[UDP_APP_OFFSET+i]='R';
      i = 5;       net_buf[UDP_APP_OFFSET+i]='C';
      i = 6;       net_buf[UDP_APP_OFFSET+i]='V';
      i = 7;       net_buf[UDP_APP_OFFSET+i]='@';
      i = 8;       net_buf[UDP_APP_OFFSET+i]='e';
      i = 9;       net_buf[UDP_APP_OFFSET+i]='q';
      i = 10;      net_buf[UDP_APP_OFFSET+i]='@';
      i = 11;      net_buf[UDP_APP_OFFSET+i]='l';
      i = 12;      net_buf[UDP_APP_OFFSET+i]='2';
      if (PTG_PTG1 == 0)			{			 
          i = 13;      net_buf[UDP_APP_OFFSET+i]='n';
    		  (void)udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
      }
      else {
          i = 13;      net_buf[UDP_APP_OFFSET+i]='f';
    		  (void)udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
      }
}

//============================================================
/* Initialize resources needed for the UDP socket application */
//============================================================
void udp_demo_init(void){

	DEBUGOUT("Initializing UDP demo client\r\n");
	
	/* Get socket:
	 * 	0 - for now not type of service implemented in UDP
	 * 	udp_echo_eventlistener - pointer to listener function
	 *	UDP_OPT_SEND_CS|UDP_OPT_CHECK_CS - checksum options. Calculate
	 *		checksum for outgoing packets and check checksum for
	 *		received packets.
	 */
	udp_demo_soch=udp_getsocket(0 , udp_demo_eventlistener , UDP_OPT_SEND_CS | UDP_OPT_CHECK_CS);
	
	if(udp_demo_soch == -1){
		DEBUGOUT("No free UDP sockets!! \r\n");
		RESET_SYSTEM();
	}
	
	/* open socket for receiving/sending of the data on defined UDP_DEMO_RMTHOST_PRT*/
	(void)udp_open(udp_demo_soch,UDP_DEMO_PORT);
	
	/* for now no data sending */
	udp_demo_senddata=0;
}

//============================================================
/* UDP Demo app main loop that is periodically invoked from the
 * main loop (see main_con.c)
 */
//============================================================
void udp_demo_run(void){

  	(void)udp_demo_send();
  	(void)get_a2d(0);

#if (~GAMEMODE & 1)               		 
	  check_switch();
#endif //(~GAMEMODE & 1)               

}

//============================================================
/*
 * Event listener invoked when TCP/IP stack receives UDP datagram for
 * a given socket. Parameters:
 * - cbhandle - handle of the socket this packet is intended for. Check it
 *	just to be sure, but in general case not needed
 * - event - event that is notified. For UDP, only UDP_EVENT_DATA
 * - UDP_DEMO_RMTHOST_IP - IP address of remote host who sent the UDP datagram
 * - UDP_DEMO_RMTHOST_PRT - UDP_DEMO_RMTHOST_PRT number of remote host who sent the UDP datagram
 * - buffindex - buffer index in RTL8019AS allowing you to read 
 * 	received data more than once from Ethernet controller by
 *	invoking NETWORK_RECEIVE_INITIALIZE(buffindex) and then start
 *	reading the bytes all over again
 */ 
//============================================================
INT32 udp_demo_eventlistener (INT8 cbhandle, UINT8 event, UINT32 ipaddr, UINT16 port, UINT16 buffindex, UINT16 datalen) {

   UINT16 	i;

	if(cbhandle!=udp_demo_soch){
  		DEBUGOUT("Not my handle!!!!");
	  	return (-1);
	}
	switch(event){
		case UDP_EVENT_DATA:
			
			/* read data to transmit buffer and send response*/
			if(datalen>(NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET))
			  datalen=NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET;
  		RECEIVE_NETWORK_BUF(data_buffer+UDP_APP_OFFSET,datalen);
			if (datalen <= 3 ) {
        ETH_DEBUGOUT("Check data is an LED command\n");
  			//LEDs
 				if (data_buffer[UDP_APP_OFFSET+0] == 'l') {
#if !(GAMEMODE)               
                OldSwitchValue=255;
                OldPot=1050;
#endif                
 				  if (data_buffer[UDP_APP_OFFSET+1] == '1') {
 				    if (data_buffer[UDP_APP_OFFSET+2] == 'n') {
      	        PTG_PTG0 = 0;			
 				     }
 				     else if (data_buffer[UDP_APP_OFFSET+2] == 'f') {
 				        PTG_PTG0 = 1;		}
 				   }
 				   else if (data_buffer[UDP_APP_OFFSET+1] == '2') 
 				   {
 				      if (data_buffer[UDP_APP_OFFSET+2] == 'n') {
 				         PTG_PTG1 = 0;	}
 				      else if (data_buffer[UDP_APP_OFFSET+2] == 'f') {
 				         PTG_PTG1 = 1;	}
 				   }
 				   else if (data_buffer[UDP_APP_OFFSET+1] == '3') 
 				   {
 				      if (data_buffer[UDP_APP_OFFSET+2] == 'n') {
 				         PTG_PTG2 = 0;	}
 				      else if (data_buffer[UDP_APP_OFFSET+2] == 'f') {
 				         PTG_PTG2 = 1;	}
 				   }
 				   else if (data_buffer[UDP_APP_OFFSET+1] == '4') 
 				   {
 				      if (data_buffer[UDP_APP_OFFSET+2] == 'n') {
 				         PTG_PTG3 = 0;	}
 				      else if (data_buffer[UDP_APP_OFFSET+2] == 'f') {
 				         PTG_PTG3 = 1;	}
 				   }
 				   
 				   
 				}
//#if !(GAMEMODE)               
   				else  // 	if (data_buffer[UDP_APP_OFFSET+0] == 'l') {
   				{
              for(i=0;i<datalen;i++)     {
                 while (!(SCI0SR1 & 0x80));
                 SCI0DRL = data_buffer[UDP_APP_OFFSET+i];	}
              sendtext("\r\n"); 
   				}
//#endif                
			}
			else 		 //			if (datalen <= 3 ) {
			{
          //Command to big - SCI bridge
//#if !(GAMEMODE)  
            for(i=0;i<datalen;i++)     {
               while (!(SCI0SR1 & 0x80));
               SCI0DRL = data_buffer[UDP_APP_OFFSET+i];
            }
           sendtext("\r\n");
//#endif                
   
			}
			
			break;
		default:
			/* should never get here */
			DEBUGOUT("Unknown UDP event :-(");
			break;
	}
	return 0;
}

//============================================================
/* internal function invoked to send UDP message to, in this case,
 * some predefined host.
 */
//============================================================
void udp_demo_send (void)	 {

		  UINT8	NewB1;
		  UINT16 i, datalen;

			datalen = 13;
      i = 0;       net_buf[UDP_APP_OFFSET+i]='c';
      i = 1;       net_buf[UDP_APP_OFFSET+i]='o';
      i = 2;       net_buf[UDP_APP_OFFSET+i]='m';
      i = 3;       net_buf[UDP_APP_OFFSET+i]='m';
      i = 4;       net_buf[UDP_APP_OFFSET+i]='R';
      i = 5;       net_buf[UDP_APP_OFFSET+i]='B';
      i = 6;       net_buf[UDP_APP_OFFSET+i]='1';
      i = 7;       net_buf[UDP_APP_OFFSET+i]='@';
      i = 8;       net_buf[UDP_APP_OFFSET+i]='e';
      i = 9;       net_buf[UDP_APP_OFFSET+i]='q';
      i = 10;      net_buf[UDP_APP_OFFSET+i]='@';
      NewB1 = PORTE_BIT0;
      if  (NewB1 != OldB1)		{
          i = 11;	 net_buf[UDP_APP_OFFSET+i]='b';
          i = 12;	 net_buf[UDP_APP_OFFSET+i]='1';
          OldB1	= NewB1;
          if (NewB1 == 0) udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
      }
      NewB1 = PTH_PTH5;
      if  (NewB1 != OldB3)		{
          i = 11;	 net_buf[UDP_APP_OFFSET+i]='b';
          i = 12;	 net_buf[UDP_APP_OFFSET+i]='3';
          OldB3	= NewB1;
          if (NewB1 == 0) udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
      }
      NewB1 = PTH_PTH6;
      if  (NewB1 != OldB4)		{
          i = 11;	 net_buf[UDP_APP_OFFSET+i]='b';
          i = 12;	 net_buf[UDP_APP_OFFSET+i]='4';
          OldB4	= NewB1;
          if (NewB1 == 0) udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
      }

}



//============================================================
//============================================================
void porth_isr_handler(void) {

		UINT8	 NewB2;
		UINT16 i, datalen;

    NewB2 = PTH_PTH4;
    if (NewB2 != OldB2) {
  		datalen = 13;
      i = 0; net_buf[UDP_APP_OFFSET+i]='c';
      i = 1; net_buf[UDP_APP_OFFSET+i]='o';
      i = 2;   net_buf[UDP_APP_OFFSET+i]='m';
      i = 3;       net_buf[UDP_APP_OFFSET+i]='m';
      i = 4;       net_buf[UDP_APP_OFFSET+i]='R';
      i = 5;       net_buf[UDP_APP_OFFSET+i]='B';
      i = 6;       net_buf[UDP_APP_OFFSET+i]='2';
      i = 7;       net_buf[UDP_APP_OFFSET+i]='@';
      i = 8;       net_buf[UDP_APP_OFFSET+i]='e';
      i = 9;       net_buf[UDP_APP_OFFSET+i]='q';
      i = 10;      net_buf[UDP_APP_OFFSET+i]='@';
    	if (NewB2 == 0) {		
          PPSH_PPSH4 = 1;		 
          i = 11;  net_buf[UDP_APP_OFFSET+i]='b';
          i = 12;  net_buf[UDP_APP_OFFSET+i]='n';
        	(void)udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
          PIFH =	PIFH_PIFH4_MASK;  //Clear Intrrupt		
    		}
    	else if  (NewB2 == 1) 	{
          PPSH_PPSH4 = 0;		 
          i = 11;  net_buf[UDP_APP_OFFSET+i]='b';
          i = 12;  net_buf[UDP_APP_OFFSET+i]='f';
        	(void)udp_send(udp_demo_soch,UDP_DEMO_RMTHOST_IP,UDP_DEMO_RMTHOST_PRT,net_buf+UDP_APP_OFFSET,NETWORK_TX_BUFFER_SIZE-UDP_APP_OFFSET,datalen);
          PIFH =	PIFH_PIFH4_MASK;  //Clear Intrrupt		
    		}
        OldB2 = NewB2;
    }
}

